=== debian/changelog ===
ddnet (16.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable another test that accesses the internet.
    (Closes: #1028113)
  * Add needs-internet to the autopkgtest.

 -- Adrian Bunk <bunk@debian.org>  Sun, 12 Feb 2023 17:42:25 +0200

ddnet (16.4-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.1

 -- Yangfl <mmyangfl@gmail.com>  Tue, 11 Oct 2022 05:55:07 +0800
