=== debian/changelog ===
ddnet (19.1-2) unstable; urgency=medium

  * Team upload.
  * Clear Cargo.lock completelty (Closes: #1102780)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 16 Apr 2025 13:04:36 +0200

ddnet (19.1-1) unstable; urgency=medium

  * Team Upload
  * New Upstream release (Closes: #1072409)
  * Add SDL2 and a lot of new Rust build dependencies
  * Disable autopkgtest that was not quite one (Closes: #1032567)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 05 Apr 2025 20:40:41 +0200

ddnet (16.4-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: Fix build with GCC-13. (Closes: #1037618)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 05 Aug 2023 15:40:19 +0200
