=== debian/control ===
--- 
+++ 
@@ -8,42 +8,54 @@
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Arch:
+ cargo,
  cmake,
- python3:native,
+ glslang-tools,
+ libavformat-dev,
+ libboost-dev,
  libcurl4-openssl-dev,
- libfreetype6-dev,
+ libfreetype-dev,
+ libglew-dev,
+ libgmock-dev <!nocheck>,
+ libgtest-dev <!nocheck>,
+ libjsonparser-dev,
+ libmariadb-dev,
+ libmysqlcppconn-dev,
+ libnotify-dev,
  libogg-dev,
  libopus-dev,
  libopusfile-dev,
+ librust-cc-dev,
+ librust-cxx-dev,
+ librust-cxx-build-dev,
+ librust-cxxbridge-flags-dev,
+ librust-cxxbridge-macro-dev,
+ librust-link-cplusplus-dev,
+ librust-proc-macro2-dev,
+ librust-quote-dev,
+ librust-syn-dev,
+ librust-unicode-ident-dev,
  libsdl2-dev,
- libmariadb-dev,
- libmysqlcppconn-dev,
- libboost-dev,
- libglew-dev,
- libwavpack-dev,
- libjsonparser-dev,
- libgtest-dev <!nocheck>,
- libgmock-dev <!nocheck>,
- libnotify-dev,
  libsqlite3-dev,
- libvulkan-dev,
- glslang-tools,
- libx264-dev,
- libavformat-dev,
  libswresample-dev,
  libswscale-dev,
+ libvulkan-dev,
+ libwavpack-dev,
+ libx264-dev,
+ python3:native,
 Rules-Requires-Root: no
 Standards-Version: 4.6.1
 Homepage: https://ddnet.tw/
 Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
 Vcs-Browser: https://salsa.debian.org/games-team/ddnet
+X-Style: black
 
 Package: ddnet
 Architecture: any
 Depends:
+ ddnet-data (>= ${source:Version}),
+ ${misc:Depends},
  ${shlibs:Depends},
- ${misc:Depends},
- ddnet-data (>= ${source:Version}),
 Description: Teeworlds modification with a unique cooperative gameplay
  DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
  modification with a unique cooperative gameplay. Help each other play through
@@ -55,9 +67,9 @@
 Package: ddnet-server
 Architecture: any
 Depends:
+ ddnet-data (>= ${source:Version}),
+ ${misc:Depends},
  ${shlibs:Depends},
- ${misc:Depends},
- ddnet-data (>= ${source:Version}),
 Suggests:
  ddnet-tools,
 Description: Server for DDNet
@@ -70,9 +82,10 @@
 
 Package: ddnet-tools
 Architecture: any
+Multi-Arch: same
 Depends:
+ ${misc:Depends},
  ${shlibs:Depends},
- ${misc:Depends},
 Description: Tools for DDNet
  DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
  modification with a unique cooperative gameplay. Help each other play through
@@ -85,8 +98,8 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
+ fonts-dejavu-core,
  ${misc:Depends},
- fonts-dejavu-core,
 Recommends:
  fonts-noto-cjk,
 Description: Data for DDNet
