=== debian/rules ===
--- 
+++ 
@@ -1,19 +1,17 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE = 1
 
+export CARGO_NET_OFFLINE=true
+export CARGO_HOME=$(shell pwd)/debian/cargo_home
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O3
+export DEB_CXXFLAGS_MAINT_APPEND = -Wno-variadic-macros
+#-Wall -pedantic -O3
+
 export DEB_LDFLAGS_MAINT_APPEND =
 
 include /usr/share/dpkg/architecture.mk
-
-ifeq ($(DEB_HOST_ARCH),ia64)
-  # gcc o3 segfault on ia64
-  # It's just annoying, not a sign I'll care about ia64
-  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
-endif
 
 
 %:
@@ -23,12 +21,12 @@
 	# pass
 
 execute_after_dh_auto_clean-indep:
-	$(RM) -r datasrc/__pycache__ datasrc/seven/__pycache__
+	$(RM) -r datasrc/__pycache__ datasrc/seven/__pycache__ debian/cargo_home/.global-cache
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -a -- \
 		-DMYSQL=ON -DAUTOUPDATE=OFF \
-		-DTESTRUNNER_ARGS=--gtest_filter=-Jobs.LookupHost:Jobs.LookupHostWebsocket
+		-DTESTRUNNER_ARGS=--gtest_filter=-Jobs.LookupHost
 
 override_dh_auto_test-arch:
 	+cd obj-$(DEB_BUILD_GNU_TYPE) && make run_tests
